var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-01\">\n\
      <meta name=\"topicid\" content=\"GUID-2BEF58D3-6162-4235-A6CE-3D8B0742A0AE\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>スレッド化と Maya</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2BEF58D3-6162-4235-A6CE-3D8B0742A0AE\"></a><div class=\"head\">\n\
            <h1>スレッド化と Maya</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55C5\"></a> \n\
            <h2><a name=\"GUID-DEDFD247-A616-45B7-8793-CE84860547AE\"></a>Maya API スレッド化インタフェースの説明と例\n\
            </h2> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55C4\"></a>このセクションでは、必要なスレッド化機能を説明することによって Maya API が提供する機能について説明し、Maya が提供するサンプル プラグインの一部の使用方法を紹介します。\n\
               \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55C3\"></a>Maya には、スレッドの作成、管理、ロックを支援する多数のスレッド化クラスがあります。これらのスレッド化クラスは、Intel の TBB スレッドに基づいて構築されており、内部処理に使用されます。また、ネイティブ\n\
               スレッドに類似した API をプラグイン作成者に公開します。これらのクラスでは、プラグイン作成者が自分のプラグインで TBB を直接使用する必要はなく、TBB に精通する必要もありません。これらのスレッドは実際は\n\
               Maya 内部スレッドであるため、適用されているスレッド数の設定が尊重され、プラグイン自体がスレッド化されたときに多数のアクティブ スレッドが作成される問題が回避されます。また、TBB\n\
               によるスレッド化の実装方法が原因で発生する可能性のあるオーバーサブスクリプションの問題からも保護します。 \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55C2\"></a>API は以下の 3 つの主要な領域の機能を提供します。 \n\
            </p> <a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55C1\"></a><ul>\n\
               <li>分岐結合スレッド化実装モデル </li>\n\
               <li>非同期タスクベース スレッド化モデル </li>\n\
               <li>スレッド化同期インタフェース </li>\n\
            </ul> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55BD\"></a>アーキテクチャはオブジェクト参照カウントを使用してメモリ管理を支援し、すべてのユーザが処理を完了するまでオブジェクトの割り当て解除を遅らせます。API 関数のコールが成功するとインタフェース\n\
               ポインタが返され、コールする側は処理が完了したらそのインタフェースに対して <span class=\"code\" translate=\"no\">release()</span> をコールします。これを実行しないと、メモリ リークが発生する場合があります。 \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55BC\"></a>コールが常に成功すると思い込まず、返される <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MStatus</a></span> は常に確認してください。 \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55BB\"></a> \n\
            <h2><a name=\"GUID-0887E609-965B-4F05-ABB7-AA327B337F38\"></a>Maya API を使用したスレッドの作成と管理\n\
            </h2> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55BA\"></a> \n\
               <h3><a name=\"GUID-7142D346-67DB-476C-8047-4F18D14EEA6E\"></a>MThreadPool\n\
               </h3> \n\
               <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55B9\"></a>このクラスはスレッド プールを作成または再利用します。スレッドの作成と削除には多くのリソースを要するため、可能な場合はスレッド プールを利用し、プラグインのコールごとにスレッドを再作成せずにコールの間スレッドを保持することをお勧めします。スレッド\n\
                  プールは参照がカウントされるため、プラグインの <span class=\"code\" translate=\"no\"> initialize()</span> メソッドでスレッドを作成してアプリケーションの継続期間は保持してから <span class=\"code\" translate=\"no\">uninitialize()</span> メソッドで解放します。ネイティブ スレッド化実装には共通のメソッドが用意されているため、プラグインをネイティブ スレッドからこの API に移行することが可能です。\n\
                  \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55B8\"></a>実装には、引数として関数ポインタを取る分岐結合コンテキストの作成が必要です。この関数は、指定された問題をTBB によってが内部処理でスレッドにマップされる小さいチャンク(タスク)に分解する機能を実装する必要があります。\n\
                  \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55B7\"></a>TBB の内部使用は、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MThreadPool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_thread_pool.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MThreadPool</a></span> で作成されたスレッド化分岐結合領域をオーバーサブスクリプションを生じることなくネストできることを意味します。TBB はこれらをコアにマップすることで、すべてのタスクを並列にスケジュール設定します。\n\
                  \n\
               </p> \n\
               <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55B6\"></a> \n\
                  <h4><a name=\"GUID-24D2206A-276D-42D7-B8E8-561BA44DA691\"></a>例\n\
                  </h4> \n\
                  <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55B5\"></a>Maya で提供されるサンプル プラグイン <span class=\"code\" translate=\"no\">threadTestCmd</span> を参照してください。このプラグインはスレッド プールを使用して素数を計算します。これには、問題をより小さいチャンクに分解するための新しい関数 <span class=\"code\" translate=\"no\">DecomposePrimes</span> を作成する必要があります。<span class=\"code\" translate=\"no\">DecomposePrimes</span> のコードは、ネイティブ スレッド化実装と非常によく似ていますが、主な違いはスレッド数ではなく、制御変数 NUM_TASKS を使用することです。上記のとおり、TBB\n\
                     は内部処理でタスクをスレッドにマップし、最適なロード バランシングを確保します。 \n\
                  </p> \n\
               </div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55B4\"></a> \n\
               <h3><a name=\"GUID-D5E54200-ED92-4535-9E3C-A9B2EAFBDF2E\"></a>MThreadAsync\n\
               </h3> \n\
               <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55B3\"></a><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MThreadAsync\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_thread_async.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MThreadAsync</a></span> クラスには、ネイティブ スレッドに共通のメソッドが用意されており、独立した非同期タスクをスレッドにマップすることが可能です。現在の実装は、このインタフェースに対してスレッド\n\
                  プールを使用するのではなく、非同期タスクごとに新しいスレッドを作成します。これはオーバーサブスクリプションが発生する可能性があることを意味しているため、非同期スレッドの数と同時に実行される作業量の管理には注意が必要です。\n\
                  \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55B2\"></a><span class=\"code\" translate=\"no\">createTask()</span> メソッドは、非同期タスクを実行する関数ポインタと、分岐結合または他の信号送信機構を実装するために開発者が使用できるコールバック関数のポインタも取ります。 \n\
               </p> \n\
               <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55B1\"></a> \n\
                  <h4><a name=\"GUID-E65BCFC7-91A2-4099-867E-8F1F9B95F9FE\"></a>例\n\
                  </h4> \n\
                  <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55B0\"></a>サンプル プラグイン <span class=\"code\" translate=\"no\">threadTestWithLocksCmd.cpp</span> を参照してください。このプラグインは Maya に付属しています。前に説明したスレッド プールの例と比較して、この実装では <span class=\"code\" translate=\"no\">DecomposePrimes</span> のような個別の関数の作成は不要です。これはネイティブ スレッド化 API に非常によく似ています。ただし、非同期スレッド化インタフェースには、結合メソッドは用意されていません。このサンプルは、コールバック関数でバリアを実装することで(<span class=\"code\" translate=\"no\">WaitForAsyncThreads</span>)、同等の機能が実装される仕組みを示しています。 \n\
                  </p> \n\
                  <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55AF\"></a>関数 <span class=\"code\" translate=\"no\">Maya_InterlockedCompare()</span> は、Maya API 提供の <span class=\"code\" translate=\"no\">MAtomic.h</span> ヘッダーでアトミック <span class=\"code\" translate=\"no\">compareAndSwap()</span> メソッドを使用するとより効率的に実装できます。 \n\
                  </p> \n\
               </div> \n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55AE\"></a> \n\
            <h2><a name=\"GUID-561189A5-90B3-40F8-8106-6553C27C3ADF\"></a>Maya API を使用したロック操作\n\
            </h2> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55AD\"></a> \n\
               <h3><a name=\"GUID-F8EA8029-A163-4ADB-828D-74391231BD6E\"></a>システム ロック\n\
               </h3> \n\
               <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55AC\"></a> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MMutexLock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_mutex_lock.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MMutexLock</a></span> と <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MSpinLock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_spin_lock.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MSpinLock</a></span> はシステム ロックです。<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MMutexLock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_mutex_lock.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MMutexLock</a></span> は、<span class=\"code\" translate=\"no\">pthread_mutex_lock</span> (OSX と Linux)と <span class=\"code\" translate=\"no\">EnterCriticalSection</span> (Windows)を使用します。これらの違いは、ミューテックス ロックの方が動作の負荷は大きくなるがロックが保持されると CPU リソースが不要になるという点数です。スピン\n\
                  ロックは負荷の軽い操作ですが、待機中に大量の CPU リソースが必要です。したがって、待機時間が短い場合はスピン ロックを使用します。これらのクラスはデストラクタでロックを解放します。つまり、明示的な解放は不要で、ロックされたコードに例外がスローされた場合でもロックは安全に解放されます。\n\
                  \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55AB\"></a>関連のないコードのロック オブジェクトの各種インスタンスを使用することをお勧めします。多数の異なる場所で単一のロック オブジェクトを使用した場合、関連のないタスクを処理していてもスレッドがブロックされることがあります。\n\
                  \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55AA\"></a> \n\
               <h3><a name=\"GUID-75F72391-2D19-4B3F-8036-8714DB49CA19\"></a>アトミック操作\n\
               </h3> \n\
               <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55A9\"></a>Maya API は <span class=\"code\" translate=\"no\">MAtomic.h</span> と呼ばれる API ヘッダにアトミック操作の実装を収め、クロスプラットフォームのアトミック操作機能を備えています。以下は、使用可能なアトミック操作のリストです。詳細な説明は、そのファイルと\n\
                  Maya API クラスの関連資料に記載されています。 \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
<a href=\"javascript:void(0)\" data-symbol=\"MAtomic::preIncrement\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_atomic.html#a6e8874b8bf5bfffb6fac137dba28f888&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MAtomic::preIncrement</a>()\n\
<a href=\"javascript:void(0)\" data-symbol=\"MAtomic::postIncrement\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_atomic.html#ac2c0d7597183016c73e3e44f3eca453b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MAtomic::postIncrement</a>()\n\
<a href=\"javascript:void(0)\" data-symbol=\"MAtomic::increment\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_atomic.html#acddba9e14f0627bf4e38792f81a47fd4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MAtomic::increment</a>()\n\
<a href=\"javascript:void(0)\" data-symbol=\"MAtomic::preDecrement\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_atomic.html#aa9a012890f5cbfe4b7cb76d29d934fd9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MAtomic::preDecrement</a>()\n\
<a href=\"javascript:void(0)\" data-symbol=\"MAtomic::postDecrement\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_atomic.html#a65228d140e8bc76f047708eaff3a9210&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MAtomic::postDecrement</a>()\n\
<a href=\"javascript:void(0)\" data-symbol=\"MAtomic::decrement\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_atomic.html#afe75af9726e9e7070d5a4ded46b49df2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MAtomic::decrement</a>()\n\
<a href=\"javascript:void(0)\" data-symbol=\"MAtomic::set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_atomic.html#afadcfa2eca88f808d9eb8b3b73c1e515&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MAtomic::set</a>()\n\
<a href=\"javascript:void(0)\" data-symbol=\"MAtomic::compareAndSwap\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_atomic.html#ada84e1d5fb08e43440e14bff2793fb69&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MAtomic::compareAndSwap</a>()\n\
</pre></div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55A8\"></a> \n\
               <h3><a name=\"GUID-037630F1-C5D2-44B9-B0A8-FF087C55A3A2\"></a>ロックとアトミック操作のパフォーマンス\n\
               </h3> \n\
               <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55A7\"></a>以下は、64 ビット版 Windows でのスピン ロックとミューテックス ロック、アトミック操作のコストに関するパフォーマンス値を示しています(OSX を除けば、他のプラットフォームも同様にはるかに低速です)。これらの数値を生成するプラグインは\n\
                  <span class=\"code\" translate=\"no\">threadingLockTests</span> と呼ばれ、ユーザが独自のシステムでテストを行うためのサンプル プラグインとして Maya に付属しています。これには OpenMP をサポートするコンパイラが必要です。このプラグインは、ロックされた領域内でコードがほとんど実際の並列処理を実行しないという極端な例です。ただし、激しい競合下でのこれらのロックの相対コストを示しています(ロックの競合は、あるスレッドがすでに保持しているロックを別のスレッドが取得しようとする場合に発生します。実行中のスレッドが増加すると、ロックの競合が起こる可能性が大幅に高まります。競合が激しくなると、パフォーマンスは大幅に低下します)。\n\
                  \n\
               </p> <a name=\"WS73099CC142F48755-1C09418211F25B18DC4-6308\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-2D358C30-14F0-41A7-BADC-80B031850969-low.png\"></div> \n\
               <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55A5\"></a>さまざまなミューテックス ロックにアトミック操作の利点があります。また、ロックを実行しないコードは、アトミック実装よりもはるかに高速になります。可能な場合はロックを回避することをお勧めします。ロックを使用する場合はアトミック操作を使用します。アトミック操作を使用できない場合にかぎり、フル\n\
                  ミューテックス ロックまたはスピン ロックを使用します。 \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55A4\"></a> <em class=\"strong\">ロックの粒度</em>は、それ自体が非常に複雑な項目です。一般的には、多数の並列処理が可能なため、疎粒度ではなく細粒度のロックが最も適切です。ただし、ロックの粒度が細かすぎると、膨大なシステム時間を消費し、コードが非常に複雑になります。課題は、ロックの粒度の最適なバランスを見つけることです。粒度が粗いロックは最も簡単であるため、このようなロックを初めて使用する場合にお勧めします。後は、パフォーマンスが向上しなくなるまで、徐々にロックの粒度を細かくしていきます。\n\
                  \n\
               </p> \n\
               <p><a name=\"WS1A9193826455F5FF-7F10494411F03A24F24-7D47\"></a>ロック操作で最悪なのは、アプリケーションが処理をまったく進行できない場合です。 \n\
               </p> <a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55A3\"></a><ul>\n\
                  <li> 2 つのスレッドがそれぞれ異なるロックを実行してから互いに他方のスレッドが保持するロックを取得しようとした場合、<em class=\"strong\">デッドロック</em>が発生します。それ以上の処理が不可能になり、アプリケーションはハングします。 \n\
                  </li>\n\
                  <li> <em class=\"strong\">ライブロック</em>はデッドロックと似ていますが、各スレッドがロックを過ぎて処理を進行せず、継続的にアクティブのままである点が異なります。たとえば、コードがデッドロックを検出しそこからロールバックはできるが、同じ評価の繰り返しを許可した場合に、サイクルが無限に繰り返される状況などです。\n\
                     \n\
                  </li>\n\
               </ul> \n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-55A0\"></a> \n\
            <h2><a name=\"GUID-C9246247-BDBE-44C3-BFE2-E59DCCDC08EC\"></a>Maya API スレッド化サンプル - デフォーマ\n\
            </h2> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-559F\"></a>Maya に付属のプラグイン <span class=\"code\" translate=\"no\">splatDeformer</span> はスレッド化デフォーマの実装サンプルです。このサンプルは、Maya ネイティブ API ではなく OpenMP を使用します。これは、スレッド化実装そのものではなくデフォーマのスレッド化に注目するためであり、OpenMP\n\
               では、スレッド化の実装のために追加する必要のあるコード量が最小であるためです。 \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-559E\"></a>デフォーマは Maya スカルプト デフォーマに少し似ています。変形メッシュは選択したメッシュの修正に使用できます。このアルゴリズムは、デフォメーションを変形オブジェクトの最近接ポイントにスナップすることでメッシュのすべてのポイントに適用します。最近接ポイント操作は計算集約型の処理であるため、オーバーヘッドがスレッド化のあらゆる利点を帳消しにしてしまう一部のより単純なデフォーマとは異なり、スレッド化に適した選択肢です。\n\
               \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-559D\"></a>以下にこの実装の注意点をいくつか示します。 \n\
            </p> <a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-559C\"></a><ul>\n\
               <li>すべての DG アクセスはスレッド化領域外で実行されます。例外はありますが、一般的に DG アクセスがスレッドセーフでないためです(下記の<span class=\"char_link\"><a href=\"#!/url=./files/GUID-2BEF58D3-6162-4235-A6CE-3D8B0742A0AE.htm#WS1A9193826455F5FF-5187222B11EEADCDC61-5589\">スレッドセーフな Maya API メソッドとクラス</a></span>を参照)。 \n\
               </li>\n\
               <li>すべての要素は、ループ トラバースを実行する iterator ではなく <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MItGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_geometry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MItGeometry</a></span> を使用して配列に読み取られます。これによりスレッドでの DG アクセスを回避し、iterator のスレッド化という困難な問題も回避します(ただし、Intel の\n\
                  OpenMP <span class=\"code\" translate=\"no\">taskq</span> 拡張機能では可能です)。 \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MItGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_geometry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MItGeometry</a></span> には、単一の関数コール(<span class=\"code\" translate=\"no\">allPositions() </span>と <span class=\"code\" translate=\"no\">setAllPositions()</span>)ですべてのポイントの読み取りと書き込みをすばやく行うことができるメソッドがあります。これは、ポイントを 1 つずつ照会して設定するよりもはるかに効率的です。Maya\n\
                  の <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh</a></span> でポイントを直接処理する場合は、新しいメソッドである <span class=\"code\" translate=\"no\">getRawPoints()</span> と <span class=\"code\" translate=\"no\">getRawNormals()</span> を使用すると、const ポインタが内部データに直接返されるためさらに高速になります。const を破棄してこのポインタを介して所定のデータを修正しないようにしてください。ほぼ確実にデータが破損します。\n\
                  \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh</a></span> の最近接ポイント メソッドはスレッドセーフではなく、固定メッシュの複数の評価にも不十分です。クラス <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MMeshIntersector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_mesh_intersector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_mesh_intersector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MMeshIntersector</a></span> はキャッシュ済みツリーのトラバースを使用するため、かなり高速でスレッドセーフでもあります。インターセクタをセットアップしてループ外で初期化してからループ内で評価されるため、並列処理の利点がすべて活かされます。\n\
                  \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\">meshPoint</span> オブジェクトはループ内に割り当てる必要があるため、現在のスレッド スタックに作成されます。オブジェクトをループ外に割り当てると、ループが競合状態を引き起こします。誤ってループ外に宣言されている変数に書き込むのは、最初はスレッド化されていなかったコードにスレッド化を追加しようとするときによく起こる問題です。このような変数はすべて特定してください。可能なかぎりローカル変数のスコープで変数を宣言し、関数の先頭での変数宣言は回避することをお勧めします。これにより、さらに将来的なスレッド化処理がより簡単になるという利点が得られます。また、可能なかぎり変数を\n\
                  const としてループの前で宣言すると、コンパイル時にループ内からのこれらの変数への書き込みアクセスを把握できます。 \n\
               </li>\n\
               <li>値は共有配列に読み書きされるため、読み取りでのキャッシュ ミスや書き込みでの偽共有が生じる危険性があります。ただし、このようなループに対する既定の OpenMP トラバース\n\
                  スキームでは、最初のスレッドが最初の(nPoints/nThreads)要素を評価し、他のスレッドは同じサイズの隣接するチャンクを評価します。このアクセス パターンにより、キャッシュ\n\
                  ミスと偽共有のいずれも最小限に抑えられます。 \n\
               </li>\n\
               <li>最近接ポイント操作が失敗した場合、エバリュエータは即座に中止されず、エラーを示すステータス フラグが設定され、残りの繰り返し処理はスキップされます。この場合、OpenMP\n\
                  はスレッド化領域内からのコールの中断を許可しません。ただし、評価中の他のスレッドを中止するのに比べて、一般的に最も簡単なアプローチです。 \n\
               </li>\n\
               <li>スレッド化領域の後に iterator が使用され、出力オブジェクトに値が書き戻されます。 </li>\n\
            </ul> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5593\"></a>拡張性はコードの順次部分によって制限されます。このため、スレッド化領域外でコードを最適化することが重要です。たとえば、最善の方法としては、DG から可能なかぎり大きなチャンクでデータの取得と設定を行うことが挙げられます。これにより\n\
               DG のオーバーヘッドが最小限に抑えられます。複数のメソッドが <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh</a></span> に追加され、1 つの操作でさまざまなタイプのコンポーネントをすべて取得することができますが、特にこのような用途に適しています。当然ながら、一度に 1 つの要素を更新する\n\
               iterator アプローチと比較すると、これらの配列は計算メソッド中は維持する必要があるため、メモリの使用量が増大する危険性があります。メソッド <span class=\"code\" translate=\"no\">MFnMesh::getRawPoints</span> は、ポインタを内部データに直接返すことによって最大速度を実現し、メモリのオーバーヘッドも回避します。 \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-7F10494411F03A24F24-7D46\"></a>一部のデフォーマはウェイトをデータブロックにキャッシュします。データブロックからの読み取りは低速で、スレッドセーフでない可能性があります。デフォーマのウェイトはフレーム単位では変化しないことが多いため、このような場合、一度ウェイトを読み取ってデフォーマ\n\
               クラス内のローカル配列に保存してから、キャッシュしたウェイト値を使用してスレッド化デフォーマの評価を行うのが最善の方法です。 \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5592\"></a> \n\
            <h2><a name=\"GUID-E78FFCD3-320F-40C4-8CFE-D42BC38872A2\"></a>Maya プラグインのシングルトン オブジェクトの初期化\n\
            </h2> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5591\"></a>一般的なコーディング パターンは、シングルトン オブジェクトの作成、あるいはソルバのグローバル データの初期化です。通常は以下が最も簡単な操作です。 \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
static solver* singleton = 0\n\
if (singleton == 0) {\n\
&nbsp;&nbsp;&nbsp;singleton = new Solver();\n\
}\n\
</pre></div> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5590\"></a>ただし、スレッド化コードの場合は非常に困難な問題になります。このパターンを実装するための最善のアプローチに関しては多くの文献がありますが、問題はオプティマイザが明らかにスレッドセーフな実装を損なうことが多いということです。明白なソリューションはロックの使用ですが、最初の構築にしか必要のない負荷の高い操作です。\n\
               \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-558F\"></a>一般的に、初期化のオーバーヘッドがあまり大きくない場合、プラグインの<span class=\"code\" translate=\"no\"> initialize()</span> メソッドに組み込むと順次実行が保証されます。 \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-558E\"></a>オブジェクトが大規模であるかまたは構築に大きなリソースが必要な場合、あるいはプラグインが常に実行されるわけではない場合は、遅延評価を使用して必要なときだけオブジェクトを初期化します。以下に、このような場合に便利な実装を示します。ここでは、Maya\n\
               に付属の <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MAtomic\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_atomic.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MAtomic</a></span> API クラスを利用します。 \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
static Solver* singleton = 0\n\
if (singleton == 0) {\n\
&nbsp;&nbsp;&nbsp;&nbsp;Solver* solver = new Solver();\n\
&nbsp;&nbsp;&nbsp;&nbsp;if(!<a href=\"javascript:void(0)\" data-symbol=\"MAtomic::compareAndSwap\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_atomic.html#ada84e1d5fb08e43440e14bff2793fb69&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MAtomic::compareAndSwap</a>(&amp;singleton, 0, solver)) {\n\
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;delete solver;\n\
&nbsp;&nbsp;&nbsp;&nbsp;}\n\
}\n\
</pre></div> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-558D\"></a>コール時に複数のスレッドが <em class=\"strong\">if </em> 条件を入力し、場合によっては同時に複数のソルバを作成します。<span class=\"code\" translate=\"no\">compareAndSwap</span> に到達した最初のスレッドは <span class=\"code\" translate=\"no\">solverSingleton</span> ポインタを新規ソルバのアドレスに設定し、後続のすべてのスレッドはソルバの作成終了後そのソルバのインスタンスを削除します。これは一見すると無駄が多いように思われますが、パフォーマンスに影響があるのは開始時のみで、後続のすべてのコード\n\
               コールは単純なポインタを実行するだけでロック処理はまったく必要ないため、実際は非常に効率的です。 \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-558C\"></a>ソルバ コンストラクタに複数のスレッドが存在すると危険であるため、以下に代替テンプレートを示します。 \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
static Solver* singleton = 0\n\
static int doneInit=0;\n\
if(<a href=\"javascript:void(0)\" data-symbol=\"MAtomic::compareAndSwap\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_atomic.html#ada84e1d5fb08e43440e14bff2793fb69&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MAtomic::compareAndSwap</a>(&amp;doneInit, 0, 1)) {\n\
&nbsp;&nbsp;&nbsp;&nbsp;singleton = new Solver();\n\
&nbsp;&nbsp;&nbsp;&nbsp;doneInit = 2;\n\
}\n\
while(doneInit != 2) {}; // spin-wait\n\
</pre></div> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-558B\"></a>このコードではソルバは必ず 1 度だけ初期化されます。コンストラクタが <span class=\"code\" translate=\"no\">solver</span> ポインタの初期化を実行したがその処理がまだ完了していない場合に他のスレッドのオブジェクトへのアクセスを防止するために、オブジェクトが完全に初期化されるまで終了しないスピンウェイト\n\
               ループが適用されています。このアプローチの欠点は、アトミック操作が必要で、後続のすべてのコールに対して、なくとも 1 回の while ループのトラバースが必要になることです。また、コンパイラについては\n\
               <span class=\"code\" translate=\"no\">doneInit=2</span> の行をコンストラクタより上に配置しているという懸念事項があります。このため、ソルバ コンストラクタ コールに関する追加ロックが必要な場合があります。 \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-558A\"></a>これは、単純なタスクであってもスレッド化環境では注意が必要であることを示す良い例です。 \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5589\"></a> \n\
            <h2><a name=\"GUID-A195C59C-A7D1-4987-A89B-C418AB284A6F\"></a>スレッドセーフな Maya API メソッドとクラス\n\
            </h2> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5588\"></a>Maya API は非常に広範なため、現時点ですべての関数とクラスがスレッドセーフかどうかを示すことは不可能です。このセクションでは、スレッド化コードで頻繁にコールされる主要なクラスをいくつか説明します。\n\
               \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5587\"></a>残念ながら、メソッドがスレッドセーフであると想定することは危険です。関数がインラインで直接確認できるものでなければ、常にコードがスレッドセーフではない危険性はあります。照会メソッドでさえも、照会により修正された内部状態をクラスが保存する場合があるため、安全ではないことがあります。\n\
               \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5586\"></a>遅延評価を使用するクラスもあるため、特定のメソッドは、スレッド化領域外でコールして内部データ構造を更新することで「準備」する必要があります。たとえば、<span class=\"code\" translate=\"no\">MFnMesh::getVertexNormal</span> は、法線が最新であることを確認し、最新でない場合は再計算します。このように、法線が最新でない場合、この関数に対して 2 つの同時コールが発生するため危険性が生じます。ただし、1\n\
               つのコールが実行されて内部データ構造が更新されると、その初回の準備コール以降、オブジェクトが修正されないかぎり後続のコールはスレッドセーフになります。 \n\
            </p> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5585\"></a> \n\
               <h3><a name=\"GUID-485F24E7-ED7B-43E1-98F9-6002BD72B8BD\"></a>スレッドセーフのクラス\n\
               </h3> <a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5584\"></a><ul>\n\
                  <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPoint</a></span>/<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFloatPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFloatPoint</a></span>/<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MVector</a></span>/<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFloatVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFloatVector</a></span>/<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_matrix.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_matrix.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MMatrix</a></span> <a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5582\"></a><ul>\n\
                        <li>すべて読み取り専用メソッドであり、書き込みメソッドはありません。 </li>\n\
                     </ul> \n\
                  </li>\n\
                  <li> <span class=\"code\" translate=\"no\">M*Array</span> コンテナ クラス \n\
                     <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-557F\"></a>配列クラスは読み取りアクセスの場合は安全です。書き込みの場合、<span class=\"code\" translate=\"no\">set()</span> メソッドは配列のサイズを変更しないため安全です。ただし、<span class=\"code\" translate=\"no\">append()</span>、<span class=\"code\" translate=\"no\">insert()</span>、<span class=\"code\" translate=\"no\">remove()</span> は配列のサイズを変更する可能性があるため、安全ではありません。 \n\
                     </p> \n\
                  </li>\n\
                  <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh</a></span> <a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-557D\"></a><ul>\n\
                        <li>closestPoint/intersection メソッドはスレッドセーフではありません。 </li>\n\
                        <li>get* と numNormals メソッドは準備が完了すると安全になります。 </li>\n\
                        <li>getRawPoints/getRawNormals はスレッドセーフです。 </li>\n\
                     </ul> \n\
                  </li>\n\
                  <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MMeshIntersector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_mesh_intersector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_mesh_intersector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MMeshIntersector</a></span> はスレッドセーフです。 \n\
                  </li>\n\
                  <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_handle.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDataHandle</a></span> メソッドは一般的にスレッドセーフとはみなされません。 <a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5577\"></a><ul>\n\
                        <li><span class=\"code\" translate=\"no\">asXXX()</span> コールは、データがクリーンかは考慮せずハンドルによって参照されるデータのポインタを返すだけであるため安全です(データの読み取りには、まず使用されることはありません)。\n\
                           \n\
                        </li>\n\
                        <li><span class=\"code\" translate=\"no\">asGenericXXX()</span> コールは、読み取り/書き込み参照カウントを使用して <span class=\"code\" translate=\"no\">Tdata</span> 情報を取得するため、安全ではありません。 \n\
                        </li>\n\
                     </ul> \n\
                     <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5574\"></a>コンテキストも重要です。一連の <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_handle.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDataHandle</a></span> オブジェクトを配置するだけで、データブロックからオブジェクトを抽出するというスレッドアンセーフな部分を既に実行していることになります。第 1 レベルの危険は、データブロックがなかなか作成されないため、まったく存在しない場合には\n\
                        1 つのスレッドのみでそれを実行する必要があることです。第 2 レベルの危険は、データを読み取るためのハンドルを取得するときに、データブロックが評価をトリガーする可能性があることです(<span class=\"code\" translate=\"no\">inputValue</span>(...) メソッドを使用する場合)。これには独自のスレッドの安全性に関する問題があります。 \n\
                     </p> \n\
                     <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5573\"></a>最も安全な計算のアルゴリズムを以下に示します。 \n\
                     </p> <a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5572\"></a><ol type=\"1\" start=\"1\">\n\
                        <li>すべての入力 <span class=\"code\" translate=\"no\">MDataHandles</span> を取得する。 \n\
                        </li>\n\
                        <li>PARALLEL (一意のハンドルからすべての入力値を取得する) </li>\n\
                        <li>計算を実行する(可能なかぎり並列処理)。 </li>\n\
                        <li>PARALLEL (すべての出力値をハンドルに入れる) </li>\n\
                        <li>PARALLEL (任意の出力値を任意の順序で取得する) </li>\n\
                     </ol> \n\
                  </li>\n\
                  <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MArrayDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_array_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_array_data_handle.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArrayDataHandle</a></span> \n\
                     <p><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-556B\"></a>このクラスは事実上データブロックへのスマート ポインタであるため内部状態を保持しており、複数のスレッドで同じハンドルを使用するときが明らかに危険です。<span class=\"code\" translate=\"no\">jumpToElement()</span> への並列コールに続いて照会コールを行う複数のスレッドはスレッドセーフではありません。 \n\
                     </p> \n\
                  </li>\n\
               </ul> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-556A\"></a> \n\
               <h3><a name=\"GUID-092314A8-D291-4149-A59F-0952FF204B4B\"></a>非スレッドセーフ機能\n\
               </h3> <a name=\"WS1A9193826455F5FF-5187222B11EEADCDC61-5569\"></a><ul>\n\
                  <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnNurbsCurve\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_nurbs_curve.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_nurbs_curve.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnNurbsCurve</a></span> 評価(ポイント オンカーブ計算など) \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnNurbsSurface\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_nurbs_surface.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_nurbs_surface.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnNurbsSurface</a></span> 評価(ポイント オンサーフェス計算など) \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFnSubd\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_subd.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnSubd</a></span> 評価 \n\
                  </li>\n\
               </ul> \n\
            </div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">このトピックについてのコメントをお送りください</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ja\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>特に明記されている場合以外は、この作業は、<a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ja\" target=\"_blank\">Creative Commons 表示 - 非営利 - 継承 3.0 非移植ライセンス</a> のもと認可を受けています。 <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> (英語版) を参照してください。</em></p><br></div>\n\
   </div></body>\n\
</html>";