var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-01\">\n\
      <meta name=\"topicid\" content=\"GUID-3435C604-A3F2-40EC-A50E-BE3018985F41\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>スレッド化の課題</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-3435C604-A3F2-40EC-A50E-BE3018985F41\"></a><div class=\"head\">\n\
            <h1>スレッド化の課題</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-70E6\"></a> \n\
            <h2><a name=\"GUID-6A7EDB1F-2A01-4304-AD36-FE57D519D337\"></a>正確性\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70E5\"></a>最も一般的なスレッド化の問題の 1 つに、2 つのスレッドが同じデータを修正しようとする<em class=\"strong\">競合状態</em>があります。データ要素の修正は、通常、アトミック操作ではないため、両方のスレッドが値を読み取り、更新し、書き込むことが可能です。このような場合、編集内容は他方のスレッドによって上書きされてしまいます。競合状態は稀にしか発生しないため、検出は非常に困難で再現も困難です。Intel\n\
               の <em class=\"strong\">ThreadChecker</em> などのツールは、競合状態の検出に適しています。これらを使用すると、実際に発生している競合状態、発生する可能性が高い状態の両方を検出できます。\n\
            </p> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70E4\"></a>競合状態が発生すると、必ず不正な結果が生じます。他にも重要度はやや低くなりますが、スレッド化コードで発生する可能性のある問題があります。たとえば、浮動小数点演算で精度が異なる問題です。減算演算を使用して値をさまざまなスレッドで累積してから集計する場合、四捨五入が異なるため、スレッドの数が最終結果に影響を与える場合があります。\n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
#pragma omp parallel for reduction(+: sum)\n\
for ( int i = 0 ; i &lt; n ; i++ ) sum += x[i]*y[i];\n\
</pre></div> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70E3\"></a>これは、小さな差異が時間とともに積み重なっていくようなシミュレーションでは重大な影響を及ぼす可能性があります。以下は、ある場所で上記と同様のコードをコールした Maya\n\
               流体ソルバの初期スレッド化実装の 2 つのイメージです。この 2 つの唯一の違いはシステム上のコアの数です。したがって、ソルバで使用されるスレッドの数も異なります。いずれの結果も<em class=\"mild\"></em>不正ではありませんが、四捨五入の違いによる外観の違いは明白です。\n\
            </p> <a name=\"WS73099CC142F487557109353211EEADCAF73-70E2\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-9115298F-7C0D-45C0-8778-1FC5D09AE897-low.png\"></div> <a name=\"WS73099CC142F487557109353211EEADCAF73-70E1\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-EAD8B7AA-4A3B-47D9-9CCC-1D80DBA90964-low.png\"></div> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70E0\"></a>この問題を回避する方法はいくつかあります。1 つは一時的に精度を高くする方法です。たとえば、スレッド化計算時に倍精度に変更します。スレッド化の利点は、高精度の計算によるパフォーマンスへの影響を上回ります。別の方法としては、データをコンパイル時に修正されるチャンクに分割して実行時にスレッドに割り当ててから、整合性のある順序でその合計を累積します。これにより、分割したチャンクのサイズがまったく変更されないため、最終合計は常に同じになります。\n\
            </p> \n\
            <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70DF\"></a>一部の C/C++ ライブラリ関数は、内部状態を維持するためにスレッドセーフではありません。たとえば、STL コンテナ(STL コンテナの読み取りもスレッドセーフでない場合があります)、<span class=\"code\" translate=\"no\">strtok()</span> などの C 関数、多くの埋め込み型乱数ジェネレータなどがあります。これらをスレッド化コードからコールする場合は注意が必要です。TBB には STL の代替コンテナとしてスレッドセーフなコンテナが用意されており、Linux\n\
               と OSX では _r 接尾辞(リエントリー用)、または Windows では _s 接尾辞が関連付けられる多くの C 関数のスレッドセーフな実装があります。たとえば、<span class=\"code\" translate=\"no\">strtok_r()</span> は <span class=\"code\" translate=\"no\">strtok()</span> のスレッドセーフなバージョンであり、<span class=\"code\" translate=\"no\">strtok_s()</span> は Windows での同等のスレッドセーフな関数です。残念ながら現在のところ、これらのスレッドセーフな関数にはクロスプラットフォーム標準がありません。\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-70DE\"></a> \n\
            <h2><a name=\"GUID-217BED7B-1AEF-4018-BFC1-ECBAD34654A8\"></a>拡張性\n\
            </h2> \n\
            <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-70DD\"></a> \n\
               <h3><a name=\"GUID-EABD7113-631E-45F5-ACF7-D2DDC10D4DD7\"></a>アムダールとグスタフソン\n\
               </h3> \n\
               <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70DC\"></a> <em class=\"strong\">アムダールの法則</em>は、問題の規模が固定されている場合、最終的にコードの順次処理部分が大きく影響して拡張性が制限されてしまうため、スレッド数を増加してもそれに応じたパフォーマンスの向上率は得られないという考えです。\n\
               </p> \n\
               <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70DB\"></a> <em class=\"strong\">グスタフソンの法則</em>は、通常、スレッド数は大規模な問題に対処するために増加されるのであって、問題の規模が固定されているというよりは実行時間が固定されているとする考えです。この場合、順次コードに対する並列コード処理の割合が問題の規模とともに増大するという条件では、パフォーマンスの向上率は無限に増加し続けます。\n\
               </p> \n\
               <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70DA\"></a>Maya のようなアプリケーションでは、前者よりも後者に近いため、適切に作成されたアルゴリズムであれば時間とともに拡張性の増大が期待できます。以下に、問題の規模が拡張性の向上につながることを示す流体ソルバの例を示します。\n\
               </p> <a name=\"WS73099CC142F487557109353211EEADCAF73-70D9\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-A723E8DB-AC88-46D8-A205-DB88586FC469-low.png\"></div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-70D8\"></a> \n\
               <h3><a name=\"GUID-719F83C5-E488-4193-899E-EA995599546C\"></a>スレッド化のオーバーヘッド\n\
               </h3> \n\
               <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70D7\"></a>スレッド プールが有効になるオーバーヘッドは約 1 万サイクルです。したがって、評価のためにこのサイクル数に近い計算を行うとスレッド化の意味がなくなります。トリップ数が大きく変化し、ループが何度もコールされるような場合、パフォーマンスへの影響を回避するために、カットオフを明示的に下げると効果が期待できます。以下の図は、Maya\n\
                  デフォーマで小規模モデルを使用したスレッド化コードと非スレッド化コードのパフォーマンスを示しています。最小規模ではスレッド化のオーバーヘッドの影響が非常に大きく、実際にシングル\n\
                  スレッド化コードがマルチスレッド化コードよりも高速です。したがって、グラフの交点より下ではスレッド化が無効になりました。\n\
               </p> <a name=\"WS73099CC142F487557109353211EEADCAF73-70D6\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-E03A2C7E-5BAC-4FE5-8A4C-A67658D8A2C4-low.png\"></div> \n\
               <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70D5\"></a>拡張性に関しては、スレッド数の増加につれてロックが高価になるという問題もあります。このため、可能なかぎりロックを使用しないか、以前よりコア数の多いマシンでアプリケーションを実行する場合は、少なくともそのアプリケーションのプロファイルを再度設定してください。コアを\n\
                  4 つに拡張するアルゴリズムでは適切に拡張されないか、または 8 つ拡張すると処理速度が低下することさえあります。\n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-70D4\"></a> \n\
               <h3><a name=\"GUID-5E7E1ED9-4FB8-4F31-903B-FC8E8C724579\"></a>ロード バランシング\n\
               </h3> \n\
               <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70D3\"></a>一部のループでは繰り返しごとに処理が大きく異なります。たとえば、メッシュの頂点のサブセットを操作するツール、または空のセルがあるボリュームでの流体ソルバの処理では、実行する処理がほぼないかまったくない繰り返しもあります。このような場合、スレッド間で要素数を均等に分割するぐらいしか選択の余地がありません。そのため、OpenMP\n\
                  のガイド付きまたはダイナミック スケジュール設定や TBB といったより均一に処理を配分できるアルゴリズムや実装を検討することも有用です。\n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-70D2\"></a> \n\
               <h3><a name=\"GUID-1A054204-A034-4340-BF6F-67CEDC8E86ED\"></a>偽共有\n\
               </h3> \n\
               <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70D1\"></a>プロセッサは、要求されたデータをローカル キャッシュに読み取ることで処理をキャッシュします。ただし、ロードされる実際のデータだけではなく、データ項目の全体的なデータのキャッシュ\n\
                  ラインが読み取られます。キャッシュ ラインのサイズは通常 64 バイトですが、この値は保証されていません。\n\
               </p> \n\
               <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70D0\"></a>偽共有とは、キャッシュへの読み取り時に同じキャッシュ ラインに常駐するメモリー内の近接した位置にある変数に対して、複数のスレッドが読み書きを行う状態を示します。1\n\
                  つのスレッドがこのような 1 つの変数に書き込みを行うと、キャッシュ ライン全体がプロセッサ キャッシュに読み取られます。このとき、別のスレッドが他のデータ要素を修正しようした場合、そのデータは、最初のプロセッサ\n\
                  キャッシュからより低レベルのキャッシュまたはメイン メモリに書き込んでから他のプロセッサ キャッシュにロードする必要があります。これによりピンポン状況になってデータ\n\
                  チャンクが連続的にプロセッサ コア間を往来するため、パフォーマンスが大幅に低下します。\n\
               </p> \n\
               <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70CF\"></a>Maya で提供されるプラグイン <span class=\"code\" translate=\"no\">threadedBoundingBox</span> には偽共のコストが図示され、回避方法が示されます。このプラグインでは、バウンディング ボックスの 1 つの要素の計算に複数のスレッドが使用されます。各スレッドは、ポイントのサブセットに対するバウンディング\n\
                  ボックスの X の最小値を表す float 値を計算します。算出された値は配列に書き込まれます。計算はさまざまな方法で実行され、シングル スレッド化されてからマルチスレッド化されて、出力結果の保持に使用される配列要素のスペーシングが変更されます。\n\
               </p> <a name=\"WS73099CC142F48755-1C09418211F25B18DC4-6309\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-BD51DABD-5C9C-4F08-BB73-EB36F5962AB1-low.png\"></div> \n\
               <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70CD\"></a>最初のテスト ケースでは、各スレッドは近接する配列要素に書き込みます。最大 8 個のコアで個別のスレッドを実行するマシンでは、各要素のサイズが 4 バイトしかないため、すべてのスレッドが同じキャッシュ\n\
                  ラインに書き込んで重大な偽共有がトリガされる可能性があります。このような場合、実際のパフォーマンスは非スレッド化実装よりも大幅に落ちます。\n\
               </p> \n\
               <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70CC\"></a>2 番目のテスト ケースでは、それぞれの値が常に個別のキャッシュ ラインに配置されるように、アクティブな配列要素間にパディングが追加されます。この場合、パフォーマンスは大幅に向上します。パディングを計算するには、最初に現在のプロセッサのキャッシュ\n\
                  ラインのサイズを照会します。Maya には、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MThreadUtils::getCacheLineSize()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_thread_utils.html#aa1dfdf0913670708cae93b9b20aa4b11&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MThreadUtils::getCacheLineSize()</a></span> という名前の新しい API メソッドがあり、ホスト プロセッサの実行時の正しい値を返します。このメソッドは、キャッシュ ライン アクセスに関してコードを適切に動作させるための最も安全な方法であり、将来的にプロセッサのキャッシュ\n\
                  ラインのサイズを拡大しても適切に動作します。\n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"WS73099CC142F487557109353211EEADCAF73-70CB\"></a> \n\
               <h3><a name=\"GUID-4E843C45-E883-4EFF-B1A2-939AE1DDE95B\"></a>ハイパースレッディング\n\
               </h3> \n\
               <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70CA\"></a>Core i7 (Nehalem)などのプロセッサにはハイパースレッディング機能が搭載されており、物理的に 1 つのコアを 2 つの論理コアとして処理し、2 つの実行スレッドを同じ物理コアで実行できる機能です。これによりパフォーマンスは向上しますが、各スレッドで多くのコア\n\
                  リソースを共有する必要があるため、2 つの物理コアと同等の効果は得られません。場合によっては、シングル スレッド化よりもパフォーマンスが低下する可能性もあります。\n\
                  \n\
               </p> \n\
               <p><a name=\"WS73099CC142F487557109353211EEADCAF73-70C9\"></a>既定では、OpenMP や TBB などのスレッド化 API が論理コアごとに 1 つのスレッドを作成するため、ハイパースレッディングを活用できます。作成したコードでハイパースレッディングの影響をテストすることは重要です。パフォーマンスの低下が見られるため実行するスレッド数を論理プロセッサ数よりも少なくする場合、オペレーティング\n\
                  システムのスケジュール設定動作を確認する必要があります。Windows XP などの古いオペレーティング システムでは、ハイパースレッディングが有効なときに必ずしも最適な方法でタスクがスレッドにスケジュール設定されるわけではなく、1\n\
                  つのコアがアイドル状態の場合に 2 つのスレッドがもう 1 つのコアで実行されることがあります。このような場合、システム BIOS でハイパースレッディングを無効にしてください。\n\
                  \n\
               </p> \n\
            </div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">このトピックについてのコメントをお送りください</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ja\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>特に明記されている場合以外は、この作業は、<a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ja\" target=\"_blank\">Creative Commons 表示 - 非営利 - 継承 3.0 非移植ライセンス</a> のもと認可を受けています。 <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> (英語版) を参照してください。</em></p><br></div>\n\
   </div></body>\n\
</html>";