var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-01\">\n\
      <meta name=\"topicid\" content=\"GUID-48A55A76-0E51-4AE7-9ED9-7E5A4E15F60E\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>.NET を使用した Hello World コマンド プラグインの作成</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-48A55A76-0E51-4AE7-9ED9-7E5A4E15F60E\"></a><div class=\"head\">\n\
            <h1>.NET を使用した Hello World コマンド プラグインの作成</h1>\n\
         </div>\n\
         <p><a name=\"GUID-C4978AE5-59FB-469D-8AD5-3A4A04B4B8D6\"></a> 次に、必要最小限のカスタム .NET コマンドの例を示します。 \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">using System;\n\
\n\
using Autodesk.Maya.Runtime;\n\
using Autodesk.Maya.OpenMaya;\n\
\n\
[assembly: MPxCommandClass(typeof(MayaNetPlugin.helloWorldCmd), \"helloWorldCmd\")]\n\
[assembly: ExtensionPlugin(typeof(MayaNetPlugin.helloWorldPlugin), \"Autodesk\", \"1.0\", \"Any\")]\n\
\n\
namespace MayaNetPlugin\n\
{\n\
    public class helloWorldPlugin : IExtensionPlugin\n\
    {\n\
        bool IExtensionPlugin.InitializePlugin()\n\
        {\n\
            return true;\n\
        }\n\
\n\
        bool IExtensionPlugin.UninitializePlugin()\n\
        {\n\
            return true;\n\
        }\n\
        String IExtensionPlugin.GetMayaDotNetSdkBuildVersion()\n\
        {\n\
            String version = \"\";\n\
            return version;\n\
        }\n\
\n\
    }\n\
\n\
    public class helloWorldCmd : <a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxCommand</a>,IMPxCommand\n\
    {\n\
        public override void doIt(<a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MArgList</a> argl)\n\
        {\n\
            MGlobal.displayInfo(\"Hello World\\n\");\n\
        }\n\
    }\n\
}</pre></div>\n\
         <p><a name=\"GUID-B67B9B3E-5CFB-4E22-9D0D-A7FBDFDC60B5\"></a>この単純な例では、Maya 出力(Output)ウィンドウに文字列を出力する helloWorld Maya コマンドを C# で作成する方法を例示します。 \n\
         </p>\n\
         <p><a name=\"GUID-672F4016-96D3-4EFC-90D3-9FAEDC3DD6B1\"></a>2 つの <em class=\"mild\"></em>using Autodesk.Maya… ディレクティブは、.NET SDK のネームスペースを追加します。このようにすると、これらのネームスペースの型を修飾なしで使用できます。ディレクティブを使用しないと、<span class=\"code\" translate=\"no\">Autodesk.Maya.OpenMaya.MPxCommand</span> のように、ファイル内で型の完全な名前を記述する必要があります。 \n\
         </p>\n\
         <p><a name=\"GUID-2DA0D8F2-ECA1-4296-83AE-3D0025DF4E95\"></a>このプラグインは、2 つの論理的な部分で構成されます。<span class=\"code\" translate=\"no\">IExtensionPlugin</span> インタフェースの実装と、コマンド自体です。 \n\
         </p>\n\
         <p><a name=\"GUID-82E987DC-0541-49ED-AB62-D4D9AD6D1AEE\"></a><span class=\"code\" translate=\"no\">ExtensionPlugin</span> アセンブリ アトリビュートは、<span class=\"code\" translate=\"no\">IExtensionPlugin</span> の実装を指します。 \n\
         </p>\n\
         <p><a name=\"GUID-2A822BA3-342A-415C-9516-24E05949893F\"></a><span class=\"code\" translate=\"no\">IExtensionPlugin.InitializePlugin()</span> を実装するとき、初期化を続行できる場合は true を返します。プラグインをロードできない場合は、false が返されて、Maya はロード処理を中止します。<span class=\"code\" translate=\"no\">IExtensionPlugin.UninitializePlugin()</span> についても同じです。 \n\
         </p>\n\
         <p><a name=\"GUID-42C00C20-8E7A-4E1A-B4C5-C53C511B080C\"></a><span class=\"code\" translate=\"no\">IExtensionPlugin.GetMayaDotNetSdkBuildVersion()</span> を実装するときは、プラグインのビルドに使用している API のバージョン番号を返すか、または空の文字列を返すことができます。 \n\
         </p>\n\
         <p><a name=\"GUID-AD4D01CB-C0A7-43F0-AB78-794728AF1CCD\"></a><span class=\"code\" translate=\"no\">MPxCommandClass</span> アセンブリのアトリビュートは、プラグインのタイプを .NET SDK に対して示します。<span class=\"code\" translate=\"no\">MPxCommandClass</span> アトリビュートは、ユーザ定義コマンドを実装しているクラスの型とコマンドの名前をパラメータとして受け取る必要があります。クラスの型を指定するには、<span class=\"code\" translate=\"no\">typeof</span> 演算子を使用します。アトリビュートは <em class=\"mild\"></em>MayaNetPlugin ネームスペースの外部にあるので、<span class=\"code\" translate=\"no\">typeof</span> 演算子にはネームスペースを含むクラスのフル パスを指定する必要があります。 \n\
         </p>\n\
         <p><a name=\"GUID-11D58311-48BD-4C42-80FE-C3356F80E885\"></a><em class=\"mild\"></em>namespace MayaNetPlugin: すべての型は、ネームスペース内で宣言されている必要があります。C# のネームスペースは、クラス、構造体、インタフェース、列挙を含むことができます。ネームスペースは、コードを整理したり、名前の衝突を防ぐのに役立ちます。\n\
            \n\
         </p>\n\
         <p><a name=\"GUID-71CD8341-9A4F-4A4E-BCA2-B847B8B4776C\"></a><em class=\"mild\"></em>public class helloWorldCmd : MPxCommand, IMPxCommand: helloWorldCmd クラスは、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxCommand</a></span> クラスから派生し、<span class=\"code\" translate=\"no\">IMPxCommand</span> インタフェースを実装します。複数のインタフェースを使用できますが、1 つのクラスからのみ派生できます。<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxCommand</a></span> はユーザ コマンドの基本クラスであり、すべてのコマンドはこのクラスから派生します。 \n\
         </p>\n\
         <p><a name=\"GUID-E5E2AA0A-6E49-4842-8FE8-EB7DE898133B\"></a><em class=\"mild\"></em>public override void doIt(MArgList argl): コマンドのアクションを実行するには、doIt() を使用します。 \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">このトピックについてのコメントをお送りください</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ja\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>特に明記されている場合以外は、この作業は、<a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ja\" target=\"_blank\">Creative Commons 表示 - 非営利 - 継承 3.0 非移植ライセンス</a> のもと認可を受けています。 <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> (英語版) を参照してください。</em></p><br></div>\n\
   </div></body>\n\
</html>";