var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-01\">\n\
      <meta name=\"topicid\" content=\"GUID-5F3F9272-0968-4AAD-8F0E-A54230E664A3\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Maya .NET API で IEnumerable および LINQ を使用する</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5F3F9272-0968-4AAD-8F0E-A54230E664A3\"></a><div class=\"head\">\n\
            <h1>Maya .NET API で IEnumerable および LINQ を使用する</h1>\n\
         </div>\n\
         <p><a name=\"GUID-61651C63-FD86-4F34-8AE2-1F31CAB9FB7D\"></a>Maya .NET API の多くのクラスに <span class=\"code\" translate=\"no\">IEnumerable&lt;T&gt;</span>インタフェースが実装されています。一部の例には、<span class=\"code\" translate=\"no\">MCGeometry</span>、<span class=\"code\" translate=\"no\">MCDag</span>、<span class=\"code\" translate=\"no\">MCDependencyGraph</span> などのヘルパー クラスに加えて、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MColorArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_color_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_color_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MColorArray</a></span>、<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"MFloatPointArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFloatPointArray</a></span> などのさまざまな Maya 配列クラスも含まれています。<span class=\"code\" translate=\"no\">IEnumerable&lt;T&gt;</span>を実装しているすべてのクラスを表示するには、オブジェクト ブラウザを使用して <span class=\"code\" translate=\"no\">GetEnumerator()</span> を検索します。 \n\
         </p><a name=\"FIG_0374F6EFA69A4E638929B44228D8AD1A\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-DE6089A3-D614-4230-B51F-547914053577-low.png\"></div>\n\
         <p><a name=\"GUID-31C8B35A-F059-4B1C-8929-201DDD14B000\"></a><span class=\"code\" translate=\"no\">GetEnumerator()</span> 関数(<span class=\"code\" translate=\"no\">IEnumerable</span> を実装する関数を含む)を実装し、<span class=\"code\" translate=\"no\">IEnumerator</span> インタフェースに準拠しているクラスを返す任意のクラスで <span class=\"code\" translate=\"no\">foreach</span> キーワードを使用できます。たとえば、シーン内で選択したオブジェクトを使用して、次のコードを実行すると、選択したすべてのオブジェクトのパス名が表示されます。 \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">foreach (var s in MGlobal.activeSelectionList)\n\
           MGlobal.displayInfo(s.partialPathName);</pre></div>\n\
         <p><a name=\"GUID-124EBCC7-04F6-458C-BFBD-82CFC9A5D8BB\"></a><span class=\"code\" translate=\"no\">System.Linq</span> ネームスペースを読み込むと、<span class=\"code\" translate=\"no\">IEnumerable&lt;T&gt;</span>を実装しているすべてのコレクションで LINQ 拡張メソッドを使用できます。たとえば、次のコードでは、選択したすべてのメッシュが返されます。 \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">var meshes = MGlobal.activeSelectionList.Where(p =&gt; p.hasFn(MFn.Type.kMesh)).Select(p =&gt; new <a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh</a>(p)); </pre></div>\n\
         <p><a name=\"GUID-C8ABA92F-787F-406C-B9D2-CD7D5B3B0E77\"></a>これは、「メソッド構文」と呼ばれます。LINQ でサポートされるその他の構文は、「クエリー構文」と呼ばれます。次のコードは、前のコードと同じです。 \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">var meshes = from p in MGlobal.activeSelectionList where p.hasFn(MFn.Type.kMesh) select new <a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh</a>(p);</pre></div>\n\
         <p><a name=\"GUID-73774C23-7CEF-43FD-9738-C79B31C50242\"></a>その他の LINQ の使用例については、Developer Kit インストールの <span class=\"code\" translate=\"no\">devkit¥dotnet¥wpfexamples</span> フォルダにある DAGExplorer のサンプルを参照してください。 \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">このトピックについてのコメントをお送りください</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ja\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>特に明記されている場合以外は、この作業は、<a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ja\" target=\"_blank\">Creative Commons 表示 - 非営利 - 継承 3.0 非移植ライセンス</a> のもと認可を受けています。 <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> (英語版) を参照してください。</em></p><br></div>\n\
   </div></body>\n\
</html>";