var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-01\">\n\
      <meta name=\"topicid\" content=\"GUID-B1CD0989-EB49-46BE-934F-F23BFB869142\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Python API 2.0 を使用する</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-B1CD0989-EB49-46BE-934F-F23BFB869142\"></a><div class=\"head\">\n\
            <h1>Python API 2.0 を使用する</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_0F347E5AF4A14C88835B5A6ADCE78BF4\"></a> \n\
            <h2><a name=\"GUID-F2134305-6A71-4DAD-AC5F-1B87D897664B\"></a>Python API 2.0 を使用する\n\
            </h2> \n\
            <p><a name=\"GUID-649DC164-05CE-4D3B-9D0A-5ABF2E88EEA7\"></a>新しい Python API モジュールは、<span class=\"code\" translate=\"no\">maya.api</span> にあります。 例:  \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.api.OpenMaya as om</pre></div> \n\
            <p><a name=\"GUID-E2F7914D-24A2-4B69-B8C8-D7688818C6E5\"></a>モジュール名は古い API と同じですが、プロキシ クラス(<em class=\"mild\">MPx</em> で始まるクラス)は、それ自身のモジュールを持たず、他の関連クラスと同じモジュールに常駐します。これは、より C++ API に似た構造になっています。 \n\
            </p> \n\
            <p><a name=\"GUID-CEF82A1F-39C1-490B-858F-A986D4B4F1DE\"></a>クラス名は、古い Python API および C++ API の場合と同じです。 メソッド名はほとんど同じで、ワークフローに影響する場合にいくつかの違いがあります。\n\
               単にオブジェクト上で値を取得または設定するメソッドのいくつかは、Python オブジェクト アトリビュートに置き換えられました。 \n\
            </p> \n\
            <p><a name=\"GUID-DD28EB3C-FA0F-4F53-8908-8A2C899791C9\"></a>新しい API クラスと古い API クラスを同じスクリプト内で使用することができますが、それらのオブジェクトには相互運用性はありません。 したがって、以下は実行可能です。\n\
               \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.api.OpenMaya as newOM\n\
import maya.OpenMaya as oldOM\n\
\n\
newAttrObj = newOM.MObject()\n\
oldNodeObj = oldOM.MObject()\n\
\n\
#...\n\
\n\
newAttrFn = newOM.MFnAttribute(newAttrObj)\n\
oldNodeFn = oldOM.MFnDependencyNode(oldNodeObj)\n\
	\n\
# OKAY: Print names from old and new function sets.\n\
print(\"Attribute name is %s.%s\" % (oldNodeFn.name(), newAttrFn.name))</pre></div> \n\
            <p><a name=\"GUID-01A93C9A-9AA0-46B4-92A8-57B7813D12F6\"></a>しかし、以下は実行できません。 \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.api.OpenMaya as newOM\n\
import maya.OpenMaya as oldOM\n\
\n\
newAttrObj = newOM.MObject()\n\
oldNodeObj = oldOM.MObject()\n\
\n\
#...\n\
\n\
# BAD: Passing an old API <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MObject</a> to a new API method.\n\
newPlug = newOM.MPlug(oldNodeObj, newAttrObj)</pre></div> \n\
            <p><a name=\"GUID-2A3DF722-5F39-48C0-B01A-2431874D16DA\"></a>クラスとメソッド名が 2 つの API 間でまったく同一の場合、混乱の可能性が高くなります。したがって、可能であればそれらを混用しないでください。 \n\
            </p> \n\
            <p><a name=\"GUID-29D9CC9F-6FBF-451F-B7B7-4916E8695A2E\"></a>新しい API を使用するプラグインを記述する場合、プラグインは maya_useNewAPI と呼ばれる関数を定義しなければなりません。これによって、Maya は、古い\n\
               API からではなく新しい API からオブジェクトをプラグインに渡すことができます。 次に例を示します。 \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">def maya_useNewAPI():\n\
    pass</pre></div> \n\
            <p><a name=\"GUID-D2F59EE6-43B7-4D99-B88B-56F6590B9052\"></a>Maya のヘルプ メニューから利用可能なオンラインのコメント送付サイト、および Autodesk Developer Network を利用し、この新しい Python\n\
               API についてのフィードバックをぜひお寄せください。 \n\
            </p> \n\
            <p><a name=\"GUID-740929A4-1D24-4537-873F-1B47AB9A3C92\"></a>Python 2.0 クラスのリストについては、<a href=\"#!/url=./py_ref/index.html\">Maya Python API 2.0 リファレンス</a>を参照してください。 \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">このトピックについてのコメントをお送りください</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ja\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>特に明記されている場合以外は、この作業は、<a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ja\" target=\"_blank\">Creative Commons 表示 - 非営利 - 継承 3.0 非移植ライセンス</a> のもと認可を受けています。 <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> (英語版) を参照してください。</em></p><br></div>\n\
   </div></body>\n\
</html>";