var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MAYAUL\">\n\
      <meta name=\"release\" content=\"2017\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2017-06-01\">\n\
      <meta name=\"topicid\" content=\"GUID-D92830AD-7CB7-4FDD-B008-2AF1F11F0CD6\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>例: シーンの作成</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D92830AD-7CB7-4FDD-B008-2AF1F11F0CD6\"></a><div class=\"head\">\n\
            <h1>例: シーンの作成</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_620BF6B473474897857CB88EE16A61B1\"></a> \n\
            <h2><a name=\"GUID-C73FFE5B-47A4-420A-970E-0C29A261E686\"></a>例: シーンの作成\n\
            </h2> \n\
            <p><a name=\"GUID-729F2B35-ACAC-4AC3-B5F2-6CB6D0C422F1\"></a> <em class=\"strong\">ファイル名:</em> <span class=\"code\" translate=\"no\"> sampleScene.py</span> \n\
            </p> \n\
            <p><a name=\"GUID-CAA1922B-3040-43B6-9E23-C72E72F605EB\"></a> <em class=\"strong\">出力例:</em> \n\
            </p> \n\
            <p><a name=\"GUID-A9DB2ABB-CE85-409E-8731-0EFCC9994AED\"></a></p> <img src=\"images/GUID-C1E39419-B720-4627-8B5E-17105AA48489-low.png\"> \n\
            <p><a name=\"GUID-BB2662DE-BCED-4CED-9FAC-7510022519E9\"></a><em class=\"strong\">プログラムの概要:</em> 次のプラグイン コードは、<span class=\"code\" translate=\"no\">OpenMayaMPx.MPxCommand</span> クラスを継承することによって、新しいコマンド <span class=\"code\" translate=\"no\">cmds.mySampleScene()</span> を作成します。このコマンドを実行すると、簡単な家のようなポリゴンを持つ赤いシェードのメッシュ、照準が家の方向にコンストレイントされたスポットライト、新しいビュー\n\
               ポイントを定義するための新しいカメラが作成されます。最後に、シーン グラフ(DAG)がトラバースされて、スクリプト エディタの出力ウィンドウに表示されます。上のサンプル出力と一致するように、ビューアの「スムーズ\n\
               シェーディング(smooth shading)」、「ワイヤフレーム付きシェード(wireframe on shaded)」、「すべてのライトの使用(use all\n\
               lights)」の各ボタンをアクティブ化します。 \n\
            </p> <a name=\"SECTION_DEFE8AF92EF14CBEBF21B23A46316393\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-092CB8DC-C8D6-464F-990E-8287AFD3F8F1\"></a><span class=\"collapsible-section-title\">Python API 2.0:</span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># pySampleScene.py\n\
\n\
import sys\n\
import maya.api.OpenMaya as OpenMaya\n\
import maya.api.OpenMayaUI as OpenMayaUI\n\
\n\
def maya_useNewAPI():\n\
	\"\"\"\n\
	The presence of this function tells Maya that the plugin produces, and\n\
	expects to be passed, objects created using the Maya Python API 2.0.\n\
	\"\"\"\n\
	pass\n\
\n\
kPluginCmdName = \"pySampleScene\"\n\
\n\
# Vertices used to define a planar house shape within a single <a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh</a> object:\n\
#\n\
#              [4]\n\
#             /   \\\n\
#            /     \\\n\
#          [3]-----[2]        where the bracketed numbers correspond\n\
#           |       |         to the vertex index.\n\
#           |       |\n\
#          [0]-----[1]\n\
#\n\
vertices = [ # Square plane:\n\
             <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPoint</a>( -2, -2, 0), # index 0: bottom left corner\n\
             <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPoint</a>(  2, -2, 0), # index 1: bottom right corner\n\
             <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPoint</a>(  2,  2, 0), # index 2: top right corner\n\
             <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPoint</a>( -2,  2, 0), # index 3: top left corner\n\
             # Vertex used to define the roof:\n\
             <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPoint</a>(  0,  5, 0)  # index 4: tip of the roof.\n\
            ]\n\
   \n\
\n\
# Count the number of times this command has been instantiated.\n\
commandInstanceCounter = 1\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class SampleSceneCommand(<a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxCommand</a>):\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand.__init__\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html#a0e33c57b86f794759092176b16cc0b44&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPxCommand.__init__</a>(self)\n\
        \n\
        # We keep track of the number of times the command was instantiated, and we label this particular\n\
        # instance of the command with it. This will help us name the objects manipulated by this particular instance \n\
        # of the command.\n\
        global commandInstanceCounter\n\
        self.commandExecution = commandInstanceCounter\n\
        commandInstanceCounter = commandInstanceCounter + 1\n\
    \n\
    \n\
    def doIt(self, args):\n\
        \'\'\' Set up the objects which the command will use. \'\'\'\n\
        \n\
        # This <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a> object will allow us to undo and redo the creation of DAG nodes in our command.\n\
        self.dagModifier = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagModifier</a>()\n\
        \n\
        # We first create the required MObjects using the MDagModifer assigned to self.dagModifier.\n\
        #   (!) The \'transform\', \'spotLight\' and \'camera\' strings are recognized by the <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a> as valid node type names. \n\
        #       For a complete list of node type names, consult the Maya User Guide  &gt; Technical Documentation &gt; Nodes section.\n\
        self.meshTransformObj = self.dagModifier.createNode( \'transform\' )\n\
        self.meshShapeObj = self.createHouseMesh() # This function will create a mesh under the self.meshTransformObj node.\n\
        \n\
        self.lightTransformObj = self.dagModifier.createNode( \'transform\' )\n\
        self.lightShapeObj = self.dagModifier.createNode( \'spotLight\', self.lightTransformObj )\n\
        \n\
        self.cameraTransformObj = self.dagModifier.createNode( \'transform\' )\n\
        self.cameraShapeObj = self.dagModifier.createNode( \'camera\', self.cameraTransformObj )\n\
        \n\
        # Create the shading node.\n\
        self.shadingNodeName = \'myMaterial\' + str( self.commandExecution )\n\
        self.dagModifier.commandToExecute( \'shadingNode -asShader -name \' + self.shadingNodeName + \' phong;\' )\n\
        self.dagModifier.commandToExecute( \'setAttr \"\' + self.shadingNodeName + \'.color\" -type double3 0.7 0.2 0.15;\')\n\
        \n\
        # Create the shading group.\n\
        self.shadingGroupName = \'myShadingGroup\' + str( self.commandExecution )\n\
        self.dagModifier.commandToExecute( \'sets -renderable true -noSurfaceShader true -empty -name \' + self.shadingGroupName + \';\')\n\
        self.dagModifier.commandToExecute( \'connectAttr -f \' + self.shadingNodeName + \'.outColor \' + self.shadingGroupName + \'.surfaceShader;\' )\n\
        \n\
        # Invoke the command\'s redoIt() function to actually create and manipulate these objects.\n\
        self.redoIt()\n\
    \n\
    \n\
    def createHouseMesh(self):\n\
        \'\'\' Create a house mesh. \'\'\'\n\
        global vertices # we want to access the list of vertices defined as a static variable  \n\
\n\
        # Create the function set for operating on the mesh\n\
        meshFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnMesh</a>( )\n\
\n\
        # Create a mesh and set this function set to operate on it.\n\
        # The mesh consists of 2 polygons: a square plane and a triangle roof. The second parameter gives the number of vertices for each.\n\
        # The third parameter is the sequence of vertices, partitioned according to the second parameter.\n\
        # Therefore, the 4 vertices numbered 0, 1, 2, 3 are used for the square, and the 3 vertices 2, 4, 3 for the triangle.\n\
        # The mesh is parented under the transform node.\n\
        meshShapeObj = meshFn.create(vertices, (4,3), (0,1,2,3,2,4,3), parent=self.meshTransformObj)\n\
                \n\
        # Set the name of the mesh.\n\
        meshFn.setName( \'myMeshShape\' + str( self.commandExecution ) )\n\
        \n\
        return meshShapeObj\n\
        \n\
    \n\
    def redoIt(self):\n\
        \'\'\' \n\
        Manipulate the objects created in doIt(). This function is also called by Maya when\n\
        the user re-does the operation after undoing it.\n\
        \'\'\'\n\
        \n\
        # Perform the operations enqueued within our reference to MDagModifier.\n\
        self.dagModifier.doIt()\n\
        \n\
        #=======================================\n\
        # MESH MANIPULATION\n\
        #=======================================\n\
        # Set the translation value of the mesh\'s transform node, as well as its name.\n\
        transformFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_transform.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnTransform</a>( self.meshTransformObj )\n\
        transformFn.setTranslation( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MVector</a>( 0, 2, 0 ), <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSpace.kTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_space.html#adcf1dba26aeb417e59c4718fb0b05ff3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSpace.kTransform</a> )\n\
        transformFn.setName( \'myMeshTransform\' + str( self.commandExecution ) )\n\
        \n\
        # Obtain the DAG path of the mesh transform node. This will be used to create\n\
        # an aiming constraint between the light and the mesh.\n\
        \n\
        meshTransformDagPath = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        dagmeshNodeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnDagNode</a>( self.meshTransformObj )\n\
        meshTransformDagPath = dagmeshNodeFn.getPath()\n\
\n\
        # The DAG path of the mesh shape node will be used to apply a material.\n\
\n\
        meshShapeDagPath = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        dagshapeNodeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnDagNode</a>( self.meshShapeObj )\n\
        meshShapeDagPath = dagshapeNodeFn.getPath( )    \n\
                \n\
        #=======================================\n\
        # LIGHT MANIPULATION\n\
        #=======================================\n\
        # Set the translation value of the light\'s transform node, as well as its name.\n\
        transformFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_transform.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnTransform</a>( self.lightTransformObj )\n\
        transformFn.setTranslation( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MVector</a>( 4, 9.5, 12 ), <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSpace.kTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_space.html#adcf1dba26aeb417e59c4718fb0b05ff3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSpace.kTransform</a> )\n\
        transformFn.setName( \'myLightTransform\' + str( self.commandExecution ) )\n\
        \n\
        # Obtain the DAG path of the light transform node. This will be used to create\n\
        # an aiming constraint between the light and the mesh.\n\
\n\
        lightTransformDagPath = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        daglightNodeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnDagNode</a>( self.lightTransformObj  )\n\
        lightTransformDagPath = daglightNodeFn.getPath()\n\
        \n\
        # Change the name of the light shape\n\
        spotLightFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDependencyNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dependency_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnDependencyNode</a>( self.lightShapeObj )\n\
        spotLightFn.setName( \'myLightShape\' + str( self.commandExecution ) )\n\
\n\
        #=======================================\n\
        # CAMERA MANIPULATION\n\
        #=======================================\n\
        # Set the translation value of the camera\'s transform node, as well as its name. \n\
        transformFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_transform.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnTransform</a>( self.cameraTransformObj )\n\
        transformFn.setTranslation( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MVector</a>( 0, 5, 30 ), <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSpace.kTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_space.html#adcf1dba26aeb417e59c4718fb0b05ff3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSpace.kTransform</a> )\n\
        transformFn.setName( \'myCameraTransform\' + str( self.commandExecution ) )\n\
        \n\
        # Change the name of the camera shape.\n\
        cameraFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_camera.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnCamera</a>( self.cameraShapeObj )\n\
        cameraFn.setName( \'myCameraShape\' + str( self.commandExecution ) )\n\
        \n\
        # Store the previous camera before we switch to the camera created within this command.\n\
        # In undo() we will revert to this previous camera.\n\
        self.previousCamera = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        currentView = <a href=\"javascript:void(0)\" data-symbol=\"OpenMayaUI.M3dView.active3dView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m3d_view.html#af45e4e174b851359e97faa8d32d1972c&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMayaUI.M3dView.active3dView</a>()\n\
        self.previousCamera=currentView.getCamera()    # self.previousCamera is now populated with the current camera before we switch.\n\
\n\
        # Get the DAG path of our camera shape node.\n\
        cameraDagPath = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        dagNodeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnDagNode</a>( self.cameraShapeObj )\n\
        # dagNodeFn.getPath( cameraDagPath )\n\
        cameraDagPath = dagNodeFn.getPath()\n\
        \n\
        # Set the camera view to the one we switched\n\
        currentView.setCamera( cameraDagPath )\n\
        \n\
        #=======================================\n\
        # AIM CONSTRAINT\n\
        #=======================================\n\
        # Enqueue a MEL command to aim the light to the mesh\'s transform node. We must use MEL\n\
        # because there is currently no way to enqueue calls to the maya.cmds Python module.\n\
        self.dagModifier.commandToExecute( \'aimConstraint -aimVector 0.0 0.0 -1.0 \' \n\
                                           + meshTransformDagPath.fullPathName() + \' \' \n\
                                           + lightTransformDagPath.fullPathName() )\n\
        \n\
        # Execute the MEL command we just added to the MDagModifier. By adding this command to the <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a>,\n\
        # we are able to undo it using MDagModifier.undoIt() in our command\'s undoIt() method. \n\
        self.dagModifier.doIt()\n\
        \n\
        #=======================================\n\
        # PHONG MATERIAL\n\
        #=======================================\n\
        # Include our mesh shape in the shading group we have defined in this command\'s doIt() function.\n\
        self.dagModifier.commandToExecute( \'sets -e -forceElement \' + self.shadingGroupName + \' \' + meshShapeDagPath.fullPathName() )\n\
        \n\
        # Execute the queued MEL command.\n\
        self.dagModifier.doIt()\n\
        \n\
        \n\
        # Print the contents of the scene.\n\
        self.printScene()\n\
        \n\
    \n\
    def undoIt(self):\n\
        \'\'\' Undo the command. \'\'\'\n\
        \n\
        # Switch back to the previous camera\n\
        currentView = <a href=\"javascript:void(0)\" data-symbol=\"OpenMayaUI.M3dView.active3dView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m3d_view.html#af45e4e174b851359e97faa8d32d1972c&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMayaUI.M3dView.active3dView</a>()\n\
        currentView.setCamera( self.previousCamera )\n\
        \n\
        # This call to MDagModifier.undoIt() undoes all the operations within the MDagModifier.\n\
        # Observe that the number of calls to MDagModifier.undoIt() does not need to match the number of calls to MDagModifier.doIt().\n\
        self.dagModifier.undoIt()\n\
        \n\
    \n\
    def isUndoable(self):\n\
        \'\'\' This command must be undoable because it affects the structure of the DAG. \'\'\'\n\
        return True\n\
    \n\
        \n\
    def printScene(self):\n\
        \'\'\' Traverse and print the elements in the scene graph (DAG)  \'\'\'\n\
        # Create a function set which we will re-use throughout our scene graph traversal.\n\
        dagNodeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnDagNode</a>()\n\
        \n\
        # Create an iterator to traverse the scene graph starting at the world node\n\
        # (the scene\'s origin). We use a depth-first traversal, and we do not filter for\n\
        # any scene elements, as indicated by the \'OpenMaya.MFn.kInvalid\' parameter.\n\
        dagIterator = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MItDag\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MItDag</a>( OpenMaya.MItDag.kDepthFirst,\n\
                                       OpenMaya.MFn.kInvalid )\n\
\n\
        print \'=====================\'\n\
        print \' SCENE GRAPH (DAG):  \'\n\
        print \'=====================\'\n\
        \n\
        # Traverse the scene.\n\
        while( not dagIterator.isDone() ):\n\
            \n\
            # Obtain the current item.\n\
            currentObj = dagIterator.currentItem()\n\
            depth = dagIterator.depth()\n\
            \n\
            # Make our dag node function set operate on the current object.\n\
            dagNodeFn.setObject( currentObj )\n\
                       \n\
            # Extract the dag node information to print.\n\
            name = dagNodeFn.name()\n\
            type = currentObj.apiTypeStr\n\
            path = dagNodeFn.fullPathName()\n\
            \n\
            # generate our output by first incrementing the tabs based on the depth\n\
            # of the current object. This formats our output nicely.\n\
            output = \'\'\n\
            for i in range( 0, depth ):\n\
                output += \'\\t\'\n\
                \n\
            output += name + \': \' + type + \' [\' + path + \']\'\n\
            print output\n\
            \n\
            # Increment to the next item.\n\
            dagIterator.next()\n\
        \n\
        print \'=====================\'\n\
                \n\
        \n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################       \n\
def cmdCreator():\n\
    \'\'\' Creates an instance of the scripted command. \'\'\'\n\
    return SampleSceneCommand()\n\
    \n\
def initializePlugin(mobject):\n\
    \'\'\' Initializes the plug-in.\'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( \"Failed to register command: %s\\n\" % kPluginCmdName )\n\
\n\
def uninitializePlugin(mobject):\n\
    \'\'\' Uninitializes the plug-in \'\'\'\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \"Failed to unregister command: %s\\n\" % kPluginCmdName )\n\
\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin(\'pySampleScene.py\')\n\
cmds.pySampleScene()\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> <a name=\"SECTION_930586BFBF79482BBEE4BB41E04E7674\"></a><details class=\"section\">\n\
               <summary><a name=\"GUID-64B72721-91B3-486F-A9BC-E53B954E589D\"></a><span class=\"collapsible-section-title\">Python API 1.0:</span></summary>\n\
               <div class=\"collapsible-section\">\n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"># sampleScene.py\n\
\n\
import sys\n\
import maya.OpenMaya as OpenMaya\n\
import maya.OpenMayaUI as OpenMayaUI\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
\n\
kPluginCmdName = \"mySampleScene\"\n\
\n\
# Vertices used to define a planar house shape within a single <a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MFnMesh</a> object:\n\
#\n\
#              [4]\n\
#             /   \\\n\
#            /     \\\n\
#          [3]-----[2]        where the bracketed numbers correspond\n\
#           |       |         to the vertex index.\n\
#           |       |\n\
#          [0]-----[1]\n\
#\n\
vertices = [ # Square plane:\n\
             <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPoint</a>( -2, -2, 0), # index 0: bottom left corner\n\
             <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPoint</a>(  2, -2, 0), # index 1: bottom right corner\n\
             <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPoint</a>(  2,  2, 0), # index 2: top right corner\n\
             <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPoint</a>( -2,  2, 0), # index 3: top left corner\n\
             # Vertex used to define the roof:\n\
             <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPoint</a>(  0,  5, 0)  # index 4: tip of the roof.\n\
           ]\n\
\n\
# Count the number of times this command has been instantiated.\n\
commandInstanceCounter = 1\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class SampleSceneCommand(OpenMayaMPx.MPxCommand):\n\
    \n\
    def __init__(self):\n\
        \'\'\' Constructor. \'\'\'\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
        \n\
        # We keep track of the number of times the command was instantiated, and we label this particular\n\
        # instance of the command with it. This will help us name the objects manipulated by this particular instance \n\
        # of the command.\n\
        global commandInstanceCounter\n\
        self.commandExecution = commandInstanceCounter\n\
        commandInstanceCounter = commandInstanceCounter + 1\n\
    \n\
    \n\
    def doIt(self, args):\n\
        \'\'\' Set up the objects which the command will use. \'\'\'\n\
        \n\
        # This <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a> object will allow us to undo and redo the creation of DAG nodes in our command.\n\
        self.dagModifier = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagModifier</a>()\n\
        \n\
        # We first create the required MObjects using the MDagModifer assigned to self.dagModifier.\n\
        #   (!) The \'transform\', \'spotLight\' and \'camera\' strings are recognized by the <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a> as valid node type names. \n\
        #       For a complete list of node type names, consult the Maya User Guide  &gt; Technical Documentation &gt; Nodes section.\n\
        self.meshTransformObj = self.dagModifier.createNode( \'transform\' )\n\
        self.meshShapeObj = self.createHouseMesh() # This function will create a mesh under the self.meshTransformObj node.\n\
        \n\
        self.lightTransformObj = self.dagModifier.createNode( \'transform\' )\n\
        self.lightShapeObj = self.dagModifier.createNode( \'spotLight\', self.lightTransformObj )\n\
        \n\
        self.cameraTransformObj = self.dagModifier.createNode( \'transform\' )\n\
        self.cameraShapeObj = self.dagModifier.createNode( \'camera\', self.cameraTransformObj )\n\
        \n\
        # Create the shading node.\n\
        self.shadingNodeName = \'myMaterial\' + str( self.commandExecution )\n\
        self.dagModifier.commandToExecute( \'shadingNode -asShader -name \' + self.shadingNodeName + \' phong;\' )\n\
        self.dagModifier.commandToExecute( \'setAttr \"\' + self.shadingNodeName + \'.color\" -type double3 0.7 0.2 0.15;\')\n\
        \n\
        # Create the shading group.\n\
        self.shadingGroupName = \'myShadingGroup\' + str( self.commandExecution )\n\
        self.dagModifier.commandToExecute( \'sets -renderable true -noSurfaceShader true -empty -name \' + self.shadingGroupName + \';\')\n\
        self.dagModifier.commandToExecute( \'connectAttr -f \' + self.shadingNodeName + \'.outColor \' + self.shadingGroupName + \'.surfaceShader;\' )\n\
        \n\
        # Invoke the command\'s redoIt() function to actually create and manipulate these objects.\n\
        self.redoIt()\n\
    \n\
    \n\
    def createHouseMesh(self):\n\
        \'\'\' Create a house mesh. \'\'\'\n\
        global vertices # we want to access the list of vertices defined as a static variable  \n\
        \n\
        meshFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnMesh</a>()\n\
        mergeVertices = True   # a parameter indicating whether or not nearby vertices will be merged.\n\
        pointTolerance = 0.001 # the distance which determines if any two nearby vertices will be merged.\n\
        \n\
        # Create the base of the house.\n\
        squareVertexArray = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPointArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPointArray</a>()\n\
        squareVertexArray.setLength( 4 )\n\
        squareVertexArray.set( vertices[0], 0 )\n\
        squareVertexArray.set( vertices[1], 1 )\n\
        squareVertexArray.set( vertices[2], 2 )\n\
        squareVertexArray.set( vertices[3], 3 )\n\
        \n\
        # Add the square polygon to the mesh whose parent is self.meshTransformObj.\n\
        meshFn.addPolygon( squareVertexArray, mergeVertices, pointTolerance, self.meshTransformObj)\n\
        \n\
        # Create the roof of the house.\n\
        triangleVertexArray = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPointArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point_array.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MPointArray</a>()\n\
        triangleVertexArray.setLength( 3 )\n\
        triangleVertexArray.set( vertices[3], 0 )\n\
        triangleVertexArray.set( vertices[2], 1 )\n\
        triangleVertexArray.set( vertices[4], 2 ) \n\
        \n\
        # Add a triangular polygon to the mesh whose parent is self.meshTransformObj. The returned meshShapeObj is\n\
        # a reference to the mesh geometry object.\n\
        meshShapeObj = meshFn.addPolygon( triangleVertexArray, mergeVertices, pointTolerance, self.meshTransformObj)\n\
        \n\
        # Set the name of the mesh.\n\
        meshFn.setName( \'myMeshShape\' + str( self.commandExecution ) )\n\
        \n\
        return meshShapeObj\n\
        \n\
    \n\
    def redoIt(self):\n\
        \'\'\' \n\
        Manipulate the objects created in doIt(). This function is also called by Maya when\n\
        the user re-does the operation after undoing it.\n\
        \'\'\'\n\
        \n\
        # Perform the operations enqueued within our reference to MDagModifier.\n\
        self.dagModifier.doIt()\n\
        \n\
        #=======================================\n\
        # MESH MANIPULATION\n\
        #=======================================\n\
        # Set the translation value of the mesh\'s transform node, as well as its name.\n\
        transformFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_transform.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnTransform</a>( self.meshTransformObj )\n\
        transformFn.setTranslation( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MVector</a>( 0, 2, 0 ), <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSpace.kTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_space.html#adcf1dba26aeb417e59c4718fb0b05ff3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSpace.kTransform</a> )\n\
        transformFn.setName( \'myMeshTransform\' + str( self.commandExecution ) )\n\
        \n\
        # Obtain the DAG path of the mesh transform node. This will be used to create\n\
        # an aiming constraint between the light and the mesh.\n\
        meshTransformDagPath = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        transformFn.getPath( meshTransformDagPath )\n\
        \n\
        # The DAG path of the mesh shape node will be used to apply a material.\n\
        meshShapeDagPath = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        meshFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnMesh</a>( self.meshShapeObj )\n\
        meshFn.getPath( meshShapeDagPath )\n\
                \n\
        #=======================================\n\
        # LIGHT MANIPULATION\n\
        #=======================================\n\
        # Set the translation value of the light\'s transform node, as well as its name.\n\
        transformFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_transform.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnTransform</a>( self.lightTransformObj )\n\
        transformFn.setTranslation( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MVector</a>( 4, 9.5, 12 ), <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSpace.kTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_space.html#adcf1dba26aeb417e59c4718fb0b05ff3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSpace.kTransform</a> )\n\
        transformFn.setName( \'myLightTransform\' + str( self.commandExecution ) )\n\
        \n\
        # Obtain the DAG path of the light transform node. This will be used to create\n\
        # an aiming constraint between the light and the mesh.\n\
        lightTransformDagPath = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        transformFn.getPath( lightTransformDagPath )\n\
        \n\
        # Change the name of the light shape\n\
        spotLightFn = OpenMaya.MFnSpotLight( self.lightShapeObj )\n\
        spotLightFn.setName( \'myLightShape\' + str( self.commandExecution ) )\n\
\n\
        #=======================================\n\
        # CAMERA MANIPULATION\n\
        #=======================================\n\
        # Set the translation value of the camera\'s transform node, as well as its name. \n\
        transformFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_transform.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnTransform</a>( self.cameraTransformObj )\n\
        transformFn.setTranslation( <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MVector</a>( 0, 5, 30 ), <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSpace.kTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_space.html#adcf1dba26aeb417e59c4718fb0b05ff3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MSpace.kTransform</a> )\n\
        transformFn.setName( \'myCameraTransform\' + str( self.commandExecution ) )\n\
        \n\
        # Change the name of the camera shape.\n\
        cameraFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_camera.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnCamera</a>( self.cameraShapeObj )\n\
        cameraFn.setName( \'myCameraShape\' + str( self.commandExecution ) )\n\
        \n\
        # Store the previous camera before we switch to the camera created within this command.\n\
        # In undo() we will revert to this previous camera.\n\
        self.previousCamera = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        currentView = <a href=\"javascript:void(0)\" data-symbol=\"OpenMayaUI.M3dView.active3dView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m3d_view.html#af45e4e174b851359e97faa8d32d1972c&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMayaUI.M3dView.active3dView</a>()\n\
        currentView.getCamera( self.previousCamera ) # self.previousCamera is now populated with the current camera before we switch.\n\
        \n\
        # Get the DAG path of our camera shape node.\n\
        cameraDagPath = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        dagNodeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnDagNode</a>( self.cameraShapeObj )\n\
        dagNodeFn.getPath( cameraDagPath )\n\
        \n\
        # Set the camera view to the one we switched\n\
        currentView.setCamera( cameraDagPath )\n\
        \n\
        #=======================================\n\
        # AIM CONSTRAINT\n\
        #=======================================\n\
        # Enqueue a MEL command to aim the light to the mesh\'s transform node. We must use MEL\n\
        # because there is currently no way to enqueue calls to the maya.cmds Python module.\n\
        self.dagModifier.commandToExecute( \'aimConstraint -aimVector 0.0 0.0 -1.0 \' \n\
                                           + meshTransformDagPath.fullPathName() + \' \' \n\
                                           + lightTransformDagPath.fullPathName() )\n\
        \n\
        # Execute the MEL command we just added to the MDagModifier. By adding this command to the <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MDagModifier</a>,\n\
        # we are able to undo it using MDagModifier.undoIt() in our command\'s undoIt() method. \n\
        self.dagModifier.doIt()\n\
        \n\
        #=======================================\n\
        # PHONG MATERIAL\n\
        #=======================================\n\
        # Include our mesh shape in the shading group we have defined in this command\'s doIt() function.\n\
        self.dagModifier.commandToExecute( \'sets -e -forceElement \' + self.shadingGroupName + \' \' + meshShapeDagPath.fullPathName() )\n\
        \n\
        # Execute the queued MEL command.\n\
        self.dagModifier.doIt()\n\
        \n\
        \n\
        # Print the contents of the scene.\n\
        self.printScene()\n\
        \n\
    \n\
    def undoIt(self):\n\
        \'\'\' Undo the command. \'\'\'\n\
        \n\
        # Switch back to the previous camera\n\
        currentView = <a href=\"javascript:void(0)\" data-symbol=\"OpenMayaUI.M3dView.active3dView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m3d_view.html#af45e4e174b851359e97faa8d32d1972c&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMayaUI.M3dView.active3dView</a>()\n\
        currentView.setCamera( self.previousCamera )\n\
        \n\
        # This call to MDagModifier.undoIt() undoes all the operations within the MDagModifier.\n\
        # Observe that the number of calls to MDagModifier.undoIt() does not need to match the number of calls to MDagModifier.doIt().\n\
        self.dagModifier.undoIt()\n\
        \n\
    \n\
    def isUndoable(self):\n\
        \'\'\' This command must be undoable because it affects the structure of the DAG. \'\'\'\n\
        return True\n\
    \n\
        \n\
    def printScene(self):\n\
        \'\'\' Traverse and print the elements in the scene graph (DAG)  \'\'\'\n\
        # Create a function set which we will re-use throughout our scene graph traversal.\n\
        dagNodeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MFnDagNode</a>()\n\
        \n\
        # Create an iterator to traverse the scene graph starting at the world node\n\
        # (the scene\'s origin). We use a depth-first traversal, and we do not filter for\n\
        # any scene elements, as indicated by the \'OpenMaya.MFn.kInvalid\' parameter.\n\
        dagIterator = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MItDag\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">OpenMaya.MItDag</a>( OpenMaya.MItDag.kDepthFirst,\n\
                                       OpenMaya.MFn.kInvalid )\n\
\n\
        print \'=====================\'\n\
        print \' SCENE GRAPH (DAG):  \'\n\
        print \'=====================\'\n\
        \n\
        # Traverse the scene.\n\
        while( not dagIterator.isDone() ):\n\
            \n\
            # Obtain the current item.\n\
            currentObj = dagIterator.currentItem()\n\
            depth = dagIterator.depth()\n\
            \n\
            # Make our dag node function set operate on the current object.\n\
            dagNodeFn.setObject( currentObj )\n\
                       \n\
            # Extract the dag node information to print.\n\
            name = dagNodeFn.name()\n\
            type = currentObj.apiTypeStr()\n\
            path = dagNodeFn.fullPathName()\n\
            \n\
            # generate our output by first incrementing the tabs based on the depth\n\
            # of the current object. This formats our output nicely.\n\
            output = \'\'\n\
            for i in range( 0, depth ):\n\
                output += \'\\t\'\n\
                \n\
            output += name + \': \' + type + \' [\' + path + \']\'\n\
            print output\n\
            \n\
            # Increment to the next item.\n\
            dagIterator.next()\n\
        \n\
        print \'=====================\'\n\
                \n\
        \n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################       \n\
def cmdCreator():\n\
    \'\'\' Creates an instance of the scripted command. \'\'\'\n\
    return OpenMayaMPx.asMPxPtr( SampleSceneCommand() )\n\
    \n\
def initializePlugin(mobject):\n\
    \'\'\' Initializes the plug-in.\'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( \"Failed to register command: %s\\n\" % kPluginCmdName )\n\
\n\
def uninitializePlugin(mobject):\n\
    \'\'\' Uninitializes the plug-in \'\'\'\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( \"Failed to unregister command: %s\\n\" % kPluginCmdName )\n\
\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
\'\'\' \n\
# Copy the following lines and run them in Maya\'s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin(\'sampleScene.py\')\n\
cmds.mySampleScene()\n\
\n\
\'\'\'</pre></div>\n\
               </div>\n\
            </details> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">このトピックについてのコメントをお送りください</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ja\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>特に明記されている場合以外は、この作業は、<a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ja\" target=\"_blank\">Creative Commons 表示 - 非営利 - 継承 3.0 非移植ライセンス</a> のもと認可を受けています。 <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> (英語版) を参照してください。</em></p><br></div>\n\
   </div></body>\n\
</html>";